"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.userRouter = void 0;
const express_1 = require("express");
const user_record_1 = require("../records/user.record");
const errors_1 = require("../utils/errors");
exports.userRouter = (0, express_1.Router)();
exports.userRouter
    .get('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const user = yield user_record_1.UserRecord.getUser(req.params.id);
    if (!user) {
        throw new errors_1.HttpError('Cannot find user.', 404);
    }
    res.json({
        user,
    });
}))
    .post('/login', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { email, password } = req.body;
    const user = new user_record_1.UserRecord({ email, password });
    const login = yield user.login();
    res.json(login);
}))
    .post('/singup', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const user = new user_record_1.UserRecord(req.body);
    yield user.singup();
    const { id, email, name, token } = user;
    res.status(201)
        .json({
        user: { id, email, name, token }
    });
}));
//# sourceMappingURL=user.router.js.map