"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const user_record_1 = require("../records/user.record");
const defaultObj = {
    name: "Mateo Woj",
    email: "example@example.com",
    password: "123456",
};
test('Can build AdRecord', () => {
    const ad = new user_record_1.UserRecord(defaultObj);
    expect(ad.name).toBe('Mateo Woj');
    expect(ad.password).toBe('123456');
    expect(ad.email).toBe('example@example.com');
});
test('validate invalid name', () => {
    expect(() => new user_record_1.UserRecord(Object.assign(Object.assign({}, defaultObj), { name: undefined }))).toThrow("Name cannot be blank or exceed 30 characters");
    expect(() => new user_record_1.UserRecord(Object.assign(Object.assign({}, defaultObj), { name: '1234567890123456789012345678901aaaaaaaaaaaaaa' }))).toThrow("Name cannot be blank or exceed 30 characters");
});
test('validate invalid email', () => {
    expect(() => new user_record_1.UserRecord(Object.assign(Object.assign({}, defaultObj), { email: undefined }))).toThrow("Email cannot be blank or exceed 100 characters");
    expect(() => new user_record_1.UserRecord(Object.assign(Object.assign({}, defaultObj), { email: '1234567890123456789012345678901aaaaaaaaaaaaaa1234567890123456789012345678901aaaaaaaaaaaaaa1234567890123456789012345678901aaaaaaaaaaaaaa1234567890123456789012345678901aaaaaaaaaaaaaa1234567890123456789012345678901aaaaaaaaaaaaaa' }))).toThrow("Email cannot be blank or exceed 100 characters");
});
test('validate invalid password', () => {
    expect(() => new user_record_1.UserRecord(Object.assign(Object.assign({}, defaultObj), { password: undefined }))).toThrow("invalid password");
    expect(() => new user_record_1.UserRecord(Object.assign(Object.assign({}, defaultObj), { password: '1234567890123456789012345678901aaaaaaaaaaaaaa' }))).toThrow("invalid password");
});
//# sourceMappingURL=user-record.test.js.map