"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleError = exports.HttpError = exports.ValidationError = void 0;
class ValidationError extends Error {
}
exports.ValidationError = ValidationError;
class HttpError extends Error {
    constructor(message, errorCode) {
        super(message);
        this.code = errorCode;
    }
}
exports.HttpError = HttpError;
const handleError = (err, req, res, next) => {
    console.log("----------------------------------------------------------\n\n", err);
    if (err instanceof HttpError) {
        res
            .status(err.code)
            .json({
            message: err.code === 500 ? 'Sorry, please try again later' : err.message,
        });
    }
    res
        .status(err instanceof ValidationError ? 400 : 500)
        .json({
        message: err instanceof ValidationError ? err.message : 'Sorry, please try again later',
    });
};
exports.handleError = handleError;
//# sourceMappingURL=errors.js.map